var mongoose = require('mongoose');
var Schema = mongoose.Schema;

var Contenidos = new Schema({
    id: { type: Number, required: true },
    tipo: { type: String, required: true },
    texto: { type: String, required: true },
    comentario: { type: String, required: false },
    hijo: { type: Number, required: true }
});

var DiapositivasTema = new Schema({
    idCurso: { type: String, required: true },
    idTema: { type: String, required: true },
    contenidos: [Contenidos],
});

var Temas = new Schema({
    titulo: { type: String, required: true },
    fichero: { type: String, required: true },
    contenidos: [Contenidos],
    diapositivas: [DiapositivasTema]
});
 

var Curso = new Schema({
  titulo:    { type: String, required: true },
  numeroTemas: { type: Number, required: true },
  temas:    [Temas],
  creado: { type: Date, default: Date.now }    
});
 
module.exports = mongoose.model('Curso', Curso);
