$(function() {

  var ponerMarcasDiapositivas =  {
    init: function() {
      var marcasDiapositivas = $("#marcas-diapositivas").data("marcas-diapositivas");
      if(marcasDiapositivas) {
        var diapositivasPorTemas = marcasDiapositivas.split(";");
        for (var i = 0; i < diapositivasPorTemas.length; i++) {
          if (diapositivasPorTemas[i].length == 0) { 
            continue;
          }
          var marcasDiapositivasPorTema = diapositivasPorTemas[i].split(",");
          var checkbox = $("#tema"+(i+1)).find("input:checkbox");
          for (var j = 0; j < checkbox.length; j++) {
            for (var k = 0; k < marcasDiapositivasPorTema.length; k++) {
              var aux = parseInt(marcasDiapositivasPorTema[k]);
              for (var l = 0; l < aux-1; l++) {
                j++;
              }
              var marcarCheckbox  = checkbox[j];
              j++;
              $(marcarCheckbox).prop("checked", true);
              $(marcarCheckbox).parent().next().removeClass('hide');
            }
          }
        }
      }
    }
  };
  ponerMarcasDiapositivas.init();

  $("#form-curso #numero-temas").focusout(function() {
    var temas = $("#form-curso #numero-temas").val();
    if(temas == 0) {
      $("#form-curso #numero-temas").val(1);
      temas = 1;
    }
    var files = $("input[type=file]");
    if(temas != files.length) {
      if(temas > files.length) {
        for (var i = files.length; i < temas; i++) {
          var label1 = '<label id="label-titulo-tema'+ (i+1) +'">Título para el tema ' + (i+1) + '</label>';
          var input = '<input id="titulo-tema'+ (i+1) +'" type="text" class="form-control" required>';
          var label2 = '<label id="label-fichero'+ (i+1) +'">Fichero para el tema ' + (i+1) + '</label>';
          var fichero = '<input id="fichero'+ (i+1) +'" type="file" accept="text/xml" required>';
          var content = '<div>' + label1+ input + label2 + fichero + '</div>';
          $("#archivos").append('<br>');  
          $("#archivos").append(content);  
        }
      } else {
        for (var i = files.length; i > temas; i--) {
          $("#archivos").children().last().remove();
          $("#archivos").children().last().remove();
        }
      }
    }
  });

  $("#form-curso").submit(function(e) {
    e.preventDefault();
    var formData = new FormData();
    var files = $("input[type=file]");
    files.each(function() {
        var value = $(this)[0].files[0];
        var id = $(this).attr('id');
        formData.append(id, value);
    });

    var tituloTemas = $("#archivos input[type=text]");
    tituloTemas.each(function() {
        var value = $(this).val();
        var id = $(this).attr('id');
        formData.append(id, value);
    });
    
    formData.append('titulo', $("#titulo").val());
    formData.append('numeroTemas', $("#numero-temas").val());
    var salida = null;
    $.ajax({
        type: "POST",
        url: "/curso/crear/",
        data: formData,
        mimeType:"multipart/form-data",
        dataType: "json",
        contentType: false,
        cache: false,
        processData:false
    }).success(function(response) {
        salida=response;
        if(response.status == 201) {
          $("#modalCurso .texto").removeClass("alert-danger").addClass("alert-success")
          $("#modalCurso .texto").html("Curso creado correctamente");
          $("#modalCurso").modal('show');  
        } else if(response.status == 406) {
          $("#modalCurso .texto").html("Fallo al crear el curso. El fichero introducido no es valido");
          $("#modalCurso .texto").removeClass("alert-success").addClass("alert-danger");  
          $("#modalCurso").modal('show');  
        }
        
    }).error(function() {
      $("#modalCurso .texto").html("Fallo al crear el curso");
      $("#modalCurso .texto").removeClass("alert-success").addClass("alert-danger")
      console.log("fail");
    });

    $("#boton-aceptar").on('click', function() {
      $("#modalCurso").modal('hide');
      console.log(salida);
      if(salida.status == 201) {
        window.location="/curso/id/" + salida.data;
      }
    });
  });

  $(".mostar-textarea").on('click', function() {
    if($(this).children().hasClass('fa-plus')) {
      $(this).children().removeClass('fa-plus').addClass('fa-minus');
      $(this).next().removeClass('hide');
      $(this).next().next().addClass('hide');
    } else {
      $(this).children().removeClass('fa-minus').addClass('fa-plus');
      $(this).next().addClass('hide');
      if($(this).next().next().text() != "") {
        $(this).next().next().removeClass('hide');
      }else {
        $(this).next().next().addClass('hide');
      }
    }
  });

  $(".btn.btn-primary.guardar").on('click', function() {
    console.log($(this).parent().prev());
    $(this).parent().prev().children().removeClass('fa-minus').addClass('fa-plus');
    $(this).parent().addClass('hide');
    var comentario = $(this).prev().val();
    if(comentario.length != 0) {
      $(this).parent().next().html(comentario);
      $(this).parent().next().removeClass('hide');
    } else {
      comentario = "";
      $(this).parent().next().addClass('hide'); 
      console.log($(this).parent().next().text() == " ");
      $(this).parent().next().html(comentario);
    }
    var url = location.pathname + "/message";
    var idTema = $(this).data("id-tema");
    var idContenido = $(this).data("id-contenido");
    $.ajax({
        type: "POST",
        url: url,
        data: {
          idTema: idTema,
          idContenido: idContenido,
          comentario: comentario
        },
        dataType: "json",
    }).success(function(response) {
        console.log("ok");
    }).error(function() {
        console.log("fail");
    });
    
  }); 

  $('input:checkbox').on('change', function() {
    if($(this).is(":checked")){
      $(this).parent().next().removeClass('hide'); 
    } else {
      $(this).parent().next().addClass('hide');
    }
  });

  $(".generar-diapositiva").on("click", function() {
    var tema = $(this).data("tema");
    var curso = $(this).data('curso');
    var parent =  $(this).parent().parent();
    var checkbox = $(parent).find("input:checkbox");
    var contenido = [];
    $(parent).find(".guardar").each(function() {
      contenido.push($(this).data("id-contenido"));
    });
    var cont = 0;
    var aux = [];
    var diapositivas = [];
    $(checkbox).each(function() {
      if($(this).is(":checked")) {
        aux.push(contenido[cont]);
        diapositivas.push(aux);
        aux = [];
      }else {
        aux.push(contenido[cont]);
      }
      cont++;
    });

    if(aux.length != 0) {
      diapositivas.push(aux);
    } 
    var formData = new FormData();
    var nombre = "diapositiva";
    var aux;
    for (var i = 0; i < diapositivas.length; i++) {
      aux = "";
      for (var j = 0; j < diapositivas[i].length; j++) {
        aux += diapositivas[i][j]+";";
      };
      formData.append(nombre+i, aux.substring(0, aux.length-1));
    };
    formData.append('nDiapositivas', i);
    formData.append('tema', tema);
    formData.append('curso', curso);
    $.ajax({
        type: "POST",
        url: "/curso/diapositiva/crear/",
        data: formData,
        dataType: "json",
        contentType: false,
        cache: false,
        processData:false
    }).success(function(response) {
        console.log("ok");
        $("#modalCurso .texto").removeClass("alert-danger").addClass("alert-success")
        $("#modalCurso .texto").html("Diapositiva generada correctamente");
        $("#modalCurso").modal('show');
    }).error(function() {
        $("#modalCurso .texto").removeClass("alert-success").addClass("alert-danger")
        $("#modalCurso .texto").html("Fallo al generar la diapositiva");
        $("#modalCurso").modal('show');
    });

    $("#boton-aceptar").on('click', function() {
      $("#modalCurso").modal('hide');
    });
    
  })



});